%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                                                                    %
%                                                                    %
%                                                                    %
%                                                                    %
%                                                                    %
%                                                                    %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


function [NDoF, ASSMtrx] = dofdrive(NELE, NODES, DomNodeID)
    ASSMtrx = zeros(21, NELE);
    GlobalDoFID = zeros(5, NODES);

    % Definition of the array GlobalDoFID(ldof,ignode)
    igdofcount = 1;
    for iele = 1:NELE
        nadd = 0;
        icount = igdofcount;
        ildofcount = 0;
        for ilnode = 1:9
            ignode = DomNodeID(ilnode, iele);
            if GlobalDoFID(1, ignode) == 0
                nadd = nadd + 1;
            end
        end
        for ilnode = 1:9
            ignode = DomNodeID(ilnode, iele);
            if GlobalDoFID(1,ignode) == 0
                GlobalDoFID(1,ignode) = icount;
                GlobalDoFID(2,ignode) = icount+nadd;
                icount = icount + 1;
                ildofcount = ildofcount + 2;
            end
        end
        ignode = DomNodeID(9,iele);
        GlobalDoFID(3,ignode) = GlobalDoFID(2,ignode) + 1;
        GlobalDoFID(4,ignode) = GlobalDoFID(3,ignode) + 1;
        GlobalDoFID(5,ignode) = GlobalDoFID(4,ignode) + 1;
        ildofcount = ildofcount + 3;
        igdofcount = igdofcount + ildofcount;
    end
    NDoF = igdofcount - 1;

    % Definition of Assembly Matrix
    for iele = 1:NELE
        ildof = 0;
        for ilnode = 1:9
            ignode = DomNodeID(ilnode,iele);
            ildof = ildof + 1;
            ASSMtrx(ildof,iele) = GlobalDoFID(1,ignode);
        end
        for ilnode = 1:9
            ignode = DomNodeID(ilnode,iele);
            ildof = ildof + 1;
            ASSMtrx(ildof,iele) = GlobalDoFID(2,ignode);
        end   
        %Pressure
        ignode = DomNodeID(9,iele);
        ASSMtrx(ildof+1,iele) = GlobalDoFID(3,ignode);
        ASSMtrx(ildof+2,iele) = GlobalDoFID(4,ignode);
        ASSMtrx(ildof+3,iele) = GlobalDoFID(5,ignode);
    end
    
end
      