%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                                                                    %
%                                                                    %
%                                                                    %
%                                                                    %
%                                                                    %
%                                                                    %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


function plotaCamposUWP(malhaNodesQuad, nX, nY, NELE, NODES, DomNodeID, ASSMtrx, X, Y, C)
        
    xx = [1 72];
    zz = [1 60];
    
    matrixW = zeros(nY, nX);
    matrixU = zeros(nY, nX);
    matrixP = zeros(nY, nX);
    M = zeros(nY/2, nX/2);
    N = zeros(nY/2, nX/2);


    W = zeros(1, NODES);
    U = zeros(1, NODES);
    P = zeros(1, NODES);

    venc = 1;
    for iele = 1:NELE
       for ilnode = 1:9
          globalNode = DomNodeID(ilnode,iele);
          W(globalNode) = C(ASSMtrx(ilnode, iele));
          U(globalNode) = C(ASSMtrx(ilnode+9, iele));
          P(iele) = C(ASSMtrx(19, iele));
          for j = 1:nX-1
            for i = 1:nY
                if malhaNodesQuad(i, j) == globalNode
                    matrixW(i, j) = venc*C(ASSMtrx(ilnode, iele));
                    matrixU(i, j) = venc*C(ASSMtrx(ilnode+9, iele));
                    matrixP(i, j) = C(ASSMtrx(19, iele));
                end
            end
          end
       end
    end
    
    for j = 1:nX/2
        for i = 1:nY/2
                M(i,j) = matrixW(2*i-1, 2*j-1);
                N(i,j) = matrixU(2*i-1, 2*j-1);

        end
    end
    
    for i = 1:length(X)/4;
        XX(i) = X(i);
        YY(i) = Y(i);
        WW(i) = W(i);
        UU(i) = U(i);
    end
    
    figure(1);
    imagesc(xx,zz,M, [0,1.05]), colorbar, title('u_x velocity'), colormap(jet), axis off, colorbar, axis image
    
    figure(2);
    imagesc(N, [-max(matrixW(:)), max(matrixW(:))]), colorbar, title('u_y velocity'), colormap(gray), axis off, colorbar

    figure(3);
    quiverc(XX,YY,WW, UU), title('velocity vector field'),axis image;

%     figure(4);
%     imagesc(matrixP, [-max(matrixP(:)), max(matrixP(:))]), colorbar, title('Pressure'), colormap(gray), axis off

end